local position = -1

local redpush = false
local blupush = false

local redlastpush = false
local blulastpush = false

local redpts = 0
local blupts = 0

local inred = false
local inblu = false

local redrollback = false
local blurollback = false

local track = [false, false, false, false, false, false, false, false] // Blu C, Blu B, Blu A, Blu Mid, Red Mid, Red A, Red B, Red C
local start = true

local timer = 2

local warning = 100

function SetStart() {
    start = true
    redpush = false
    blupush = false
    inred = false
    inblu = false
    redrollback = false
    blurollback = false
    redpts = 0
    blupts = 0
    track = [false, false, false, false, false, false, false, false]
}

function SetWarning(pfWarning) {
    warning = pfWarning
}

function SetRedPush(pfPush) {
    redpush = pfPush
    redlastpush = true
    blulastpush = false
}

function SetBluPush(pfPush) {
    blupush = pfPush
    blulastpush = true
    redlastpush = false
}

function SetRedRollback(pfRollback) {
    redrollback = pfRollback
}

function SetBluRollback(pfRollback) {
    blurollback = pfRollback
}

function InitialPush(pfZone) {
    if (start) {
        track[pfZone] = true
        position = pfZone
        start = false
    }
}

function SetPosition(pfZone1, pfZone2) {
    if (!start) {
        track[pfZone1] = !track[pfZone1]
        track[pfZone2] = !track[pfZone2]
        foreach (i,v in track) {
            if (v) {position = i}
        }
    }

    switch(position){
        case 0: // Blu C
            timer = 0.5
            EntFireByHandle(self, "RefireTime", timer.tostring(),0,null,null)
            //printl("In Blu C zone")
            break
        case 1: // Blu B
            timer = 1
            EntFireByHandle(self, "RefireTime", timer.tostring(),0,null,null)
            //printl("In Blu B zone")
            break
        case 2: // Blu A
            timer = 2
            EntFireByHandle(self, "RefireTime", timer.tostring(),0,null,null)
            //printl("In Blu A zone")
            inblu = true
            break
        case 3: // Blu Mid
            //printl("In Blu Mid zone")
            inblu = false
            break
        case 4: // Red Mid
            //printl("In Red Mid zone")
            inred = false
            break
        case 5: // Red A
            timer = 2
            EntFireByHandle(self, "RefireTime", timer.tostring(),0,null,null)
            //printl("In Red A zone")
            inred = true
            break
        case 6: // Red B
            timer = 1
            EntFireByHandle(self, "RefireTime", timer.tostring(),0,null,null)
            //printl("In Red B zone")
            break
        case 7: // Red C
            timer = 0.5
            EntFireByHandle(self, "RefireTime", timer.tostring(),0,null,null)
            //printl("In Red C zone")
            break
        default:

        }
}

function OnTimer() {
    if (inred) {
        if ((!redpush || (!redpush && !blupush)) && !blurollback && blulastpush) {
            Entities.FindByClassname(null,"tf_logic_player_destruction").AcceptInput("ScoreBluePoints", "", null, null)
            blupts++
            if (blupts == warning) {
                Entities.FindByName(null,"tf_gamerules").AcceptInput("PlayVOBlue", "vo/announcer_plr_racegeneral12.mp3", null, null)
                Entities.FindByName(null,"tf_gamerules").AcceptInput("PlayVORed", "vo/announcer_plr_racegeneral11.mp3", null, null)
            }
        }
    }
    if (inblu) {
        if ((!blupush || (!blupush && !redpush)) && !redrollback && redlastpush) {
            Entities.FindByClassname(null,"tf_logic_player_destruction").AcceptInput("ScoreRedPoints", "", null, null)
            redpts++
            if (redpts == warning) {
                Entities.FindByName(null,"tf_gamerules").AcceptInput("PlayVORed", "vo/announcer_plr_racegeneral12.mp3", null, null)
                Entities.FindByName(null,"tf_gamerules").AcceptInput("PlayVOBlue", "vo/announcer_plr_racegeneral11.mp3", null, null)
            }
        }
    }
}