# Tow Point Prefab

### Introduction

This is a gamemode i've been working since early 2022 (before Vscript!) revisiting a community's classic: Tug of War!

Created originally to have something fun with Player Destruction's point scoring, but also to fix the stalemates and long Tug of War games. Originally it had also a timer, but got rid of it due to its complexity

The gamemode is really fun and i'm hyped to see the maps made with this prefab!

### How it works?

After a setup time, get to the cart in the middle neutral zone to push it to your ennemy's base! The further you get in the ennemy's base, the more points you score!

- A zone is 1 point every 2 seconds 
- B zone is 1 points every 1 second 
- C zone is 1 point every 0.5 seconds

Getting to the end won't cap instantly, but C zone would be a short zone there, getting you a lot of points! Only scoring the goal number of points can make you win!

### Here's what to do:

The file PointTowPrefab goes in the custom folder

A lot of things are to change first in the logic_auto next to the team train watcher. All mentions of logic_auto will be this one

- You can modify the number of points in the pd_logic, but in the logic_auto, you should change the number in ``SetWarning`` to change the number of points when it would be announced that at team is close to victory

- The hud will be need to be adapted everytime the track and/or points are different. To modify it, two different things are to be changed:
    1. Set the speed of the cart with ``SetConvert(...)`` in the logic_auto near the team_train_watcher. Yes, the number will be quite small. The cart should get around the end of the track. Make multiple compiles to try different values to find the correct value to put in the ``SetConvert(...)`` field (replace ... with your value)
    2. Get to the custom files, andn find hudobjectivetow_prefab.res, in the resource\ui folder. Inside of the res file, find ``Midpoint``, ``ZoneBlue`` and ``ZoneRed`` (with a letter from A to C behind the team names). In there, change the ``x-pos`` value to fit here the points are on your hud. You can launch your game in unsecure mode, and when you will do ``hud_reloadscheme``, it will update the hud with the new positions

- In the maps folder of the custom folder, change the name of the file inside to ``[tow_yourmapname_version]_level_sounds.txt``. This will prevent the alarms and announcer voicelines when the Blu team gets close to the point or terminus

- #### VERY IMPORTANT!!! When compiling, exclude the folder of your custom hud!!!

### More info on the gamemode:

- The mode was built with the setup timer, you must have a setup timer in it, as it is uncertain if it will work with no setup timer. It's not obligated that there is doors though. You can change the time of the timer (must be above 1 second)

- There are two spawn points in the prefab, one for when the team owns the point (attacking) and another when they don't (defending)

- Yes it is obligatory that there's two control points in the end of the tracks. Even if they are unused, they're necessary so the game doesn't end when mid point is capped

- A map for this gamemode would be actually be slightly bigger than a Koth map, so if you do port a Koth map to Tow, be sure to have a good gameplay space for each zone, and a good distance from the spawn to the objective

- Adapt the respawntime! Ideally the gamemode is supposed to have close of same respawn time for attacking and defending teams, but it can happen that once in a base, the cart wouldn't be able to get out of it and thus making no switch between attack and defend

- Yes it is intended to have no instant win at the end of the track. In a gamemode puerly on point scoring, i don't want to have an instant win skipping the core mechanic of the gamemode. Hence why zone C exists: it's supposed to make things faster if a match is really unbalanced

- 3 zones is a max, but you can have less, but at minimum it should have a short zone with fast counting at the end, and a zone with normal counting. A middle neutral zone is also necessary for the gamemode logic, but make it the lengh you want! (it's recommended that the middle zone of the map covers most of the middle area of the map)

- The prefab won't have a specificaly made cart model for this gamemode, so get your own for your map, or use an already existing one!

### Planned changes:

- Sound rework (sounds when crossing zones, fixing mid cap sounds, changing scoring sound,...)

- More zones in the prefab

- Zone point/border model (optional)


### Credits:

- Gamemode concept, scripts and scoring logic: Kiglirs
- Tug of War base logic: FubarFX
- Custom hud: Radarhead
Kiglirs and Radarhead must be credited

<br>
<br>
Thanks for using my gamemode! May your map be a great one!<br> -Kiglirs